#!/bin/bash
PRODUCTNAME="amiserv5"
TMPDIR="/tmp/amiserv5"
INSTALLDIR="/usr/share"
IPCDIR="/etc/ipconnect"
OLDVERSION=-1
NEWVERSION=-1

mkdir -p "$TMPDIR"

if [ -e "$IPCDIR/$PRODUCTNAME.ver" ]
then
	OLDVERSION=$(cat "$IPCDIR/$PRODUCTNAME.ver" |cut -d"." -f2)
fi
NEWVERSION=$(head -n 1 "$INSTALLDIR/$PRODUCTNAME/version.txt" |cut -d"." -f2)
echo "-- Updating from 5.$OLDVERSION to 5.$NEWVERSION"

for (( i = $OLDVERSION+1 ; i <= $NEWVERSION ; i++))
{
	echo "-- Executing patch 5.$i"
	find "$INSTALLDIR/$PRODUCTNAME/InstallScripts/5.$i" -name '*' -exec dos2unix {} 2> /dev/null \;
	bash "$INSTALLDIR/$PRODUCTNAME/InstallScripts/5.$i/update.sh"
}

echo "* Restoring some files"
if [ -e "$TMPDIR/Config.txt.old" ]
then
	mv -f "$TMPDIR/Config.txt.old" "$INSTALLDIR/$PRODUCTNAME/Config.txt"
fi
if [ -e "$TMPDIR/AmiServ5Service.exe.config.old" ]
then
	mv -f "$TMPDIR/AmiServ5Service.exe.config.old" "$INSTALLDIR/$PRODUCTNAME/AmiServ5Service.exe.config"
fi

if [ ! -e "$INSTALLDIR/$PRODUCTNAME/Config.txt" ]
then
	echo "* Creating $PRODUCTNAME configuration file"
	cp "$INSTALLDIR/$PRODUCTNAME/Config.txt.template" "$INSTALLDIR/$PRODUCTNAME/Config.txt"
fi
if [ ! -e "$INSTALLDIR/$PRODUCTNAME/AmiServ5Service.exe.config" ]
then
	echo "* Creating $PRODUCTNAME service configuration file"
	cp "$INSTALLDIR/$PRODUCTNAME/App.config.template" "$INSTALLDIR/$PRODUCTNAME/AmiServ5Service.exe.config"
fi

echo "-- Creating magik keys"
if [ -L "$IPCDIR/magik" ]
then
	unlink "$IPCDIR/magik"
fi
rm -rf "$INSTALLDIR/$PRODUCTNAME/magik"
mkdir "$INSTALLDIR/$PRODUCTNAME/magik"
ln -s "$INSTALLDIR/$PRODUCTNAME/magik" "$IPCDIR/magik"
uuidgen > "$INSTALLDIR/$PRODUCTNAME/magik/performance"
chmod o+r "$INSTALLDIR/$PRODUCTNAME/magik/performance"
chmod o+r "$INSTALLDIR/$PRODUCTNAME/magik/performance"

systemctl daemon-reload
systemctl start amiserv5

echo "5.$NEWVERSION" > "$IPCDIR/$PRODUCTNAME.ver"
echo "-- Update finished"

rm -rf "$TMPDIR"
exit