#!/bin/bash
PRODUCTNAME="amiserv5"
TMPDIR="/tmp/amiserv5"
INSTALLDIR="/usr/share"
IPCDIR="/etc/ipconnect"

echo "* Creating directories"
sleep 1
#Creation des repertoires
if [ ! -d "$INSTALLDIR" ];
then
	mkdir "$INSTALLDIR"
	mkdir "$INSTALLDIR/$PRODUCTNAME"
fi
if [ ! -d "$IPCDIR" ];
then
	mkdir "$IPCDIR"
fi

echo "* Trying to stop service (if exists)"
systemctl stop amiserv5 > /dev/null

echo "* Downloading new file"
rm -rf "$TMPDIR"
mkdir "$TMPDIR"
cd "$TMPDIR"
#wget -q http://support.ipconnect.fr/fichiers/Technique/Logiciels/AMIServ5/latest/Amiserv5.zip
wget -q http://support.ipconnect.fr/Prive/Amiserv5.zip

echo "* Backuping some files"
if [ -e "$INSTALLDIR/$PRODUCTNAME/Config.txt" ];
then
	mv "$INSTALLDIR/$PRODUCTNAME/Config.txt" "$TMPDIR/Config.txt.old"
fi
if [ -e "$INSTALLDIR/$PRODUCTNAME/Config.txt" ];
then
	mv "$INSTALLDIR/$PRODUCTNAME/AmiServ5Service.exe.config" "$TMPDIR/AmiServ5Service.exe.config.old"
fi

echo "* Extracting..."
rm -rf "$INSTALLDIR/$PRODUCTNAME"
unzip Amiserv5.zip -d "$INSTALLDIR/$PRODUCTNAME" > /dev/null

echo "* Restoring some files"
if [ -e "$TMPDIR/Config.txt.old" ];
then
	mv -f "$TMPDIR/Config.txt.old" "$INSTALLDIR/$PRODUCTNAME/Config.txt"
fi
if [ -e "$TMPDIR/AmiServ5Service.exe.config.old" ];
then
	mv -f "$TMPDIR/AmiServ5Service.exe.config.old" "$INSTALLDIR/$PRODUCTNAME/AmiServ5Service.exe.config"
fi

echo "* Updating...";
dos2unix "$INSTALLDIR/$PRODUCTNAME/InstallScripts/update.sh" > /dev/null
bash "$INSTALLDIR/$PRODUCTNAME/InstallScripts/update.sh"


if [ ! -e "$INSTALLDIR/$PRODUCTNAME/Config.txt" ];
then
	echo "* Creating $PRODUCTNAME configuration file"
	mv "$INSTALLDIR/$PRODUCTNAME/Config.txt.template" "$INSTALLDIR/$PRODUCTNAME/Config.txt"
fi
if [ ! -e "$INSTALLDIR/$PRODUCTNAME/AmiServ5Service.exe.config" ];
then
	echo "* Creating $PRODUCTNAME service configuration file"
	mv "$INSTALLDIR/$PRODUCTNAME/App.config.template" "$INSTALLDIR/$PRODUCTNAME/AmiServ5Service.exe.config"
fi

#Créé les clefs magiques.
if [ ! -d /usr/share/amiserv5/magik ];
then
	echo "* Creating magik keys"
	mkdir -p /usr/share/amiserv5/magik
	ln -s /usr/share/amiserv5/magik /etc/ipconnect/magik
	uuidgen > /etc/ipconnect/magik/performance
fi
chmod o+r /etc/ipconnect/magik/performance

echo "* Starting Amiserv5 service."
systemctl start amiserv5

echo "* Installation finished."
exit